#ifndef __UTIL_HH__
#define __UTIL_HH__

#include <QWidget>

#include <QWindow>
#include <QScreen>

#include <QString>
#include <QTextStream>

const QWindow *qWindowOf(const QWidget *w);
const QScreen *screenOf(const QObject *o);
QString screenName(const QWidget *w);

QTextStream &operator<<(QTextStream &s, const QSize &sz);
QTextStream &operator<<(QTextStream &s, const QRect &r);
QPoint nativeCursorPosition();
QString formatScreens(const QWidget *w = nullptr);

struct formatObject
{
    formatObject(const QObject *o) : m_o(o) {}
    const QObject *m_o;
};

QDebug operator<<(QDebug  d, const formatObject &f);

class EventFilter : public QObject
{
public:
    EventFilter(QObject *p) : QObject(p)  {}

    bool eventFilter(QObject *watched, QEvent *event) override;

    static bool logInputEvents;
};

#endif
